package mezz.jei.fabric.platform;

import mezz.jei.common.platform.IPlatformItemStackHelper;
import net.minecraft.class_1761;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1836;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import net.minecraft.class_2609;
import net.minecraft.class_310;
import net.minecraft.class_746;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.jetbrains.annotations.Nullable;

import java.util.Collection;
import java.util.List;
import java.util.Map;

public class ItemStackHelper implements IPlatformItemStackHelper {
    private static final Logger LOGGER = LogManager.getLogger();

    @Override
    public int getBurnTime(class_1799 itemStack) {
        Map<class_1792, Integer> fuels = class_2609.method_11196();
        return fuels.getOrDefault(itemStack.method_7909(), 0);
    }

    @Override
    public boolean canStack(class_1799 a, class_1799 b) {
        if (a.method_7960() || !a.method_7962(b) || a.method_7985() != b.method_7985()) {
            return false;
        }

        class_2487 tag = a.method_7969();
        return tag == null || tag.equals(b.method_7969());
    }

    @Override
    public boolean isBookEnchantable(class_1799 stack, class_1799 book) {
        return true;
    }

    @Override
    @Nullable
    public String getCreatorModId(class_1799 stack) {
        return null;
    }

    @Override
    public Collection<class_1761> getCreativeTabs(class_1799 itemStack) {
        class_1761 creativeTab = itemStack.method_7909().method_7859();
        if (creativeTab == null) {
            return List.of();
        }
        return List.of(creativeTab);
    }

    @Override
    public List<class_2561> getTestTooltip(class_1799 itemStack) {
        try {
            class_310 minecraft = class_310.method_1551();
            class_746 player = minecraft.field_1724;
            return itemStack.method_7950(player, class_1836.class_1837.field_8934);
        } catch (LinkageError | RuntimeException e) {
            LOGGER.error("Error while Testing for mod name formatting", e);
        }
        return List.of();
    }
}
